# aiod-rail-sdk
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.20240603-beta
- Package version: 1.0.0
- Generator version: 7.6.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import aiod_rail_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import aiod_rail_sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
import os

import aiod_rail_sdk
from aiod_rail_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/api
# See configuration.py for a list of all supported configuration parameters.
configuration = aiod_rail_sdk.Configuration(
    host = "http://localhost/api"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: APIKeyHeader
configuration.api_key['APIKeyHeader'] = os.environ["API_KEY"]

# Enter a context with an instance of the API client
with aiod_rail_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = aiod_rail_sdk.AssetsApi(api_client)
    dataset = aiod_rail_sdk.Dataset() # Dataset | 

    try:
        # Create Dataset
        api_response = api_instance.create_dataset_v1_assets_datasets_post(dataset)
        print("The response of AssetsApi->create_dataset_v1_assets_datasets_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AssetsApi->create_dataset_v1_assets_datasets_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdminApi* | [**approve_experiment_template_v1_experiment_templates_id_approve_patch**](docs/AdminApi.md#approve_experiment_template_v1_experiment_templates_id_approve_patch) | **PATCH** /v1/experiment-templates/{id}/approve | Approve Experiment Template
*AssetsApi* | [**create_dataset_v1_assets_datasets_post**](docs/AssetsApi.md#create_dataset_v1_assets_datasets_post) | **POST** /v1/assets/datasets | Create Dataset
*AssetsApi* | [**dataset_upload_file_to_huggingface_v1_assets_datasets_id_upload_file_to_huggingface_post**](docs/AssetsApi.md#dataset_upload_file_to_huggingface_v1_assets_datasets_id_upload_file_to_huggingface_post) | **POST** /v1/assets/datasets/{id}/upload-file-to-huggingface | Dataset Upload File To Huggingface
*AssetsApi* | [**delete_dataset_v1_assets_datasets_id_delete**](docs/AssetsApi.md#delete_dataset_v1_assets_datasets_id_delete) | **DELETE** /v1/assets/datasets/{id} | Delete Dataset
*AssetsApi* | [**get_dataset_v1_assets_datasets_id_get**](docs/AssetsApi.md#get_dataset_v1_assets_datasets_id_get) | **GET** /v1/assets/datasets/{id} | Get Dataset
*AssetsApi* | [**get_datasets_count_v1_assets_counts_datasets_get**](docs/AssetsApi.md#get_datasets_count_v1_assets_counts_datasets_get) | **GET** /v1/assets/counts/datasets | Get Datasets Count
*AssetsApi* | [**get_datasets_v1_assets_datasets_get**](docs/AssetsApi.md#get_datasets_v1_assets_datasets_get) | **GET** /v1/assets/datasets | Get Datasets
*AssetsApi* | [**get_filtered_datasets_count_v1_assets_counts_datasets_search_query_get**](docs/AssetsApi.md#get_filtered_datasets_count_v1_assets_counts_datasets_search_query_get) | **GET** /v1/assets/counts/datasets/search/{query} | Get Filtered Datasets Count
*AssetsApi* | [**get_filtered_models_count_v1_assets_counts_models_search_query_get**](docs/AssetsApi.md#get_filtered_models_count_v1_assets_counts_models_search_query_get) | **GET** /v1/assets/counts/models/search/{query} | Get Filtered Models Count
*AssetsApi* | [**get_filtered_publications_count_v1_assets_counts_publications_search_query_get**](docs/AssetsApi.md#get_filtered_publications_count_v1_assets_counts_publications_search_query_get) | **GET** /v1/assets/counts/publications/search/{query} | Get Filtered Publications Count
*AssetsApi* | [**get_model_v1_assets_models_id_get**](docs/AssetsApi.md#get_model_v1_assets_models_id_get) | **GET** /v1/assets/models/{id} | Get Model
*AssetsApi* | [**get_models_count_v1_assets_counts_models_get**](docs/AssetsApi.md#get_models_count_v1_assets_counts_models_get) | **GET** /v1/assets/counts/models | Get Models Count
*AssetsApi* | [**get_models_v1_assets_models_get**](docs/AssetsApi.md#get_models_v1_assets_models_get) | **GET** /v1/assets/models | Get Models
*AssetsApi* | [**get_my_datasets_count_v1_assets_counts_datasets_my_get**](docs/AssetsApi.md#get_my_datasets_count_v1_assets_counts_datasets_my_get) | **GET** /v1/assets/counts/datasets/my | Get My Datasets Count
*AssetsApi* | [**get_my_datasets_v1_assets_datasets_my_get**](docs/AssetsApi.md#get_my_datasets_v1_assets_datasets_my_get) | **GET** /v1/assets/datasets/my | Get My Datasets
*AssetsApi* | [**get_my_models_count_v1_assets_counts_models_my_get**](docs/AssetsApi.md#get_my_models_count_v1_assets_counts_models_my_get) | **GET** /v1/assets/counts/models/my | Get My Models Count
*AssetsApi* | [**get_my_models_v1_assets_models_my_get**](docs/AssetsApi.md#get_my_models_v1_assets_models_my_get) | **GET** /v1/assets/models/my | Get My Models
*AssetsApi* | [**get_platforms_v1_assets_platforms_get**](docs/AssetsApi.md#get_platforms_v1_assets_platforms_get) | **GET** /v1/assets/platforms | Get Platforms
*AssetsApi* | [**get_publication_v1_assets_publications_id_get**](docs/AssetsApi.md#get_publication_v1_assets_publications_id_get) | **GET** /v1/assets/publications/{id} | Get Publication
*AssetsApi* | [**get_publications_count_v1_assets_counts_publications_get**](docs/AssetsApi.md#get_publications_count_v1_assets_counts_publications_get) | **GET** /v1/assets/counts/publications | Get Publications Count
*AssetsApi* | [**get_publications_v1_assets_publications_get**](docs/AssetsApi.md#get_publications_v1_assets_publications_get) | **GET** /v1/assets/publications | Get Publications
*AssetsApi* | [**search_datasets_v1_assets_datasets_search_query_get**](docs/AssetsApi.md#search_datasets_v1_assets_datasets_search_query_get) | **GET** /v1/assets/datasets/search/{query} | Search Datasets
*AssetsApi* | [**search_models_v1_assets_models_search_query_get**](docs/AssetsApi.md#search_models_v1_assets_models_search_query_get) | **GET** /v1/assets/models/search/{query} | Search Models
*AssetsApi* | [**search_publications_v1_assets_publications_search_query_get**](docs/AssetsApi.md#search_publications_v1_assets_publications_search_query_get) | **GET** /v1/assets/publications/search/{query} | Search Publications
*ExperimentRunsApi* | [**delete_experiment_run_v1_experiment_runs_id_delete**](docs/ExperimentRunsApi.md#delete_experiment_run_v1_experiment_runs_id_delete) | **DELETE** /v1/experiment-runs/{id} | Delete Experiment Run
*ExperimentRunsApi* | [**download_file_from_experiment_run_v1_experiment_runs_id_files_download_get**](docs/ExperimentRunsApi.md#download_file_from_experiment_run_v1_experiment_runs_id_files_download_get) | **GET** /v1/experiment-runs/{id}/files/download | Download File From Experiment Run
*ExperimentRunsApi* | [**get_experiment_run_logs_v1_experiment_runs_id_logs_get**](docs/ExperimentRunsApi.md#get_experiment_run_logs_v1_experiment_runs_id_logs_get) | **GET** /v1/experiment-runs/{id}/logs | Get Experiment Run Logs
*ExperimentRunsApi* | [**get_experiment_run_v1_experiment_runs_id_get**](docs/ExperimentRunsApi.md#get_experiment_run_v1_experiment_runs_id_get) | **GET** /v1/experiment-runs/{id} | Get Experiment Run
*ExperimentRunsApi* | [**list_files_of_experiment_run_v1_experiment_runs_id_files_list_get**](docs/ExperimentRunsApi.md#list_files_of_experiment_run_v1_experiment_runs_id_files_list_get) | **GET** /v1/experiment-runs/{id}/files/list | List Files Of Experiment Run
*ExperimentTemplatesApi* | [**archive_experiment_template_v1_experiment_templates_id_archive_patch**](docs/ExperimentTemplatesApi.md#archive_experiment_template_v1_experiment_templates_id_archive_patch) | **PATCH** /v1/experiment-templates/{id}/archive | Archive Experiment Template
*ExperimentTemplatesApi* | [**create_experiment_template_v1_experiment_templates_post**](docs/ExperimentTemplatesApi.md#create_experiment_template_v1_experiment_templates_post) | **POST** /v1/experiment-templates | Create Experiment Template
*ExperimentTemplatesApi* | [**get_experiment_template_v1_experiment_templates_id_get**](docs/ExperimentTemplatesApi.md#get_experiment_template_v1_experiment_templates_id_get) | **GET** /v1/experiment-templates/{id} | Get Experiment Template
*ExperimentTemplatesApi* | [**get_experiment_templates_count_v1_count_experiment_templates_get**](docs/ExperimentTemplatesApi.md#get_experiment_templates_count_v1_count_experiment_templates_get) | **GET** /v1/count/experiment-templates | Get Experiment Templates Count
*ExperimentTemplatesApi* | [**get_experiment_templates_v1_experiment_templates_get**](docs/ExperimentTemplatesApi.md#get_experiment_templates_v1_experiment_templates_get) | **GET** /v1/experiment-templates | Get Experiment Templates
*ExperimentTemplatesApi* | [**get_experiments_of_template_count_v1_count_experiment_templates_id_experiments_get**](docs/ExperimentTemplatesApi.md#get_experiments_of_template_count_v1_count_experiment_templates_id_experiments_get) | **GET** /v1/count/experiment-templates/{id}/experiments | Get Experiments Of Template Count
*ExperimentTemplatesApi* | [**remove_experiment_template_v1_experiment_templates_id_delete**](docs/ExperimentTemplatesApi.md#remove_experiment_template_v1_experiment_templates_id_delete) | **DELETE** /v1/experiment-templates/{id} | Remove Experiment Template
*ExperimentTemplatesApi* | [**update_experiment_template_v1_experiment_templates_id_put**](docs/ExperimentTemplatesApi.md#update_experiment_template_v1_experiment_templates_id_put) | **PUT** /v1/experiment-templates/{id} | Update Experiment Template
*ExperimentsApi* | [**archive_experiment_v1_experiments_id_archive_patch**](docs/ExperimentsApi.md#archive_experiment_v1_experiments_id_archive_patch) | **PATCH** /v1/experiments/{id}/archive | Archive Experiment
*ExperimentsApi* | [**create_experiment_v1_experiments_post**](docs/ExperimentsApi.md#create_experiment_v1_experiments_post) | **POST** /v1/experiments | Create Experiment
*ExperimentsApi* | [**delete_experiment_v1_experiments_id_delete**](docs/ExperimentsApi.md#delete_experiment_v1_experiments_id_delete) | **DELETE** /v1/experiments/{id} | Delete Experiment
*ExperimentsApi* | [**execute_experiment_run_v1_experiments_id_execute_get**](docs/ExperimentsApi.md#execute_experiment_run_v1_experiments_id_execute_get) | **GET** /v1/experiments/{id}/execute | Execute Experiment Run
*ExperimentsApi* | [**get_experiment_runs_of_experiment_count_v1_count_experiments_id_runs_get**](docs/ExperimentsApi.md#get_experiment_runs_of_experiment_count_v1_count_experiments_id_runs_get) | **GET** /v1/count/experiments/{id}/runs | Get Experiment Runs Of Experiment Count
*ExperimentsApi* | [**get_experiment_runs_of_experiment_v1_experiments_id_runs_get**](docs/ExperimentsApi.md#get_experiment_runs_of_experiment_v1_experiments_id_runs_get) | **GET** /v1/experiments/{id}/runs | Get Experiment Runs Of Experiment
*ExperimentsApi* | [**get_experiment_v1_experiments_id_get**](docs/ExperimentsApi.md#get_experiment_v1_experiments_id_get) | **GET** /v1/experiments/{id} | Get Experiment
*ExperimentsApi* | [**get_experiments_count_v1_count_experiments_get**](docs/ExperimentsApi.md#get_experiments_count_v1_count_experiments_get) | **GET** /v1/count/experiments | Get Experiments Count
*ExperimentsApi* | [**get_experiments_v1_experiments_get**](docs/ExperimentsApi.md#get_experiments_v1_experiments_get) | **GET** /v1/experiments | Get Experiments
*ExperimentsApi* | [**update_experiment_v1_experiments_id_put**](docs/ExperimentsApi.md#update_experiment_v1_experiments_id_put) | **PUT** /v1/experiments/{id} | Update Experiment
*UsersApi* | [**create_or_change_user_api_key_v1_users_api_key_post**](docs/UsersApi.md#create_or_change_user_api_key_v1_users_api_key_post) | **POST** /v1/users/api_key | Create Or Change User Api Key
*UsersApi* | [**get_user_api_key_v1_users_api_key_get**](docs/UsersApi.md#get_user_api_key_v1_users_api_key_get) | **GET** /v1/users/api_key | Get User Api Key
*UsersApi* | [**get_user_profile_v1_users_profile_get**](docs/UsersApi.md#get_user_profile_v1_users_profile_get) | **GET** /v1/users/profile | Get User Profile


## Documentation For Models

 - [AIoDEntryRead](docs/AIoDEntryRead.md)
 - [Address](docs/Address.md)
 - [AssetCardinality](docs/AssetCardinality.md)
 - [AssetSchema](docs/AssetSchema.md)
 - [Dataset](docs/Dataset.md)
 - [DatasetSize](docs/DatasetSize.md)
 - [Distribution](docs/Distribution.md)
 - [EnvironmentVar](docs/EnvironmentVar.md)
 - [EnvironmentVarDef](docs/EnvironmentVarDef.md)
 - [ExperimentCreate](docs/ExperimentCreate.md)
 - [ExperimentResponse](docs/ExperimentResponse.md)
 - [ExperimentRunDetails](docs/ExperimentRunDetails.md)
 - [ExperimentRunResponse](docs/ExperimentRunResponse.md)
 - [ExperimentTemplateCreate](docs/ExperimentTemplateCreate.md)
 - [ExperimentTemplateResponse](docs/ExperimentTemplateResponse.md)
 - [FileDetail](docs/FileDetail.md)
 - [Geo](docs/Geo.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [Location](docs/Location.md)
 - [Location1Inner](docs/Location1Inner.md)
 - [MLModel](docs/MLModel.md)
 - [Note](docs/Note.md)
 - [Platform](docs/Platform.md)
 - [Publication](docs/Publication.md)
 - [RailUserResponse](docs/RailUserResponse.md)
 - [RunState](docs/RunState.md)
 - [RunnableDistribution](docs/RunnableDistribution.md)
 - [TaskType](docs/TaskType.md)
 - [TemplateState](docs/TemplateState.md)
 - [Text](docs/Text.md)
 - [ValidationError](docs/ValidationError.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="OpenIdConnect"></a>
### OpenIdConnect


<a id="APIKeyHeader"></a>
### APIKeyHeader

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header


## Author




